#include "main.h"

deadlineplane::deadlineplane(QWidget *parent)
{

}

void deadlineplane::addbasewidgets(QWidget *parent)
{
            vpcontwidget = new QWidget(this);
    vpcontwidget->setGeometry(395, 10, 481, 551);
    vpcontwidget->show();
    localviewplane = new viewplane(vpcontwidget);
//    localviewplane->setGeometry(0, 0, 481, 551);
    localviewplane->show();
//    setupUi(this);
}

void deadlineplane::setupall()
{
	localviewplane->isremote = false;
	metavp = new metaviewplane;
	remotevp = new viewplane;
	metavp->allviewplanes.append(remotevp);
        metavp->allviewplanes.append(localviewplane);
        metavp->setup();
	evparser = new icalparser;
	centertime = QDateTime::currentDateTime().toUTC();
	evparser->parsetree(QString("%1/calendars").arg(QCoreApplication::applicationDirPath()));
	evlistfull = icalparser::orderlistdown(evparser->icallist);
	evwidgetlist = icalparser::towidgetlist(evlistfull);
	scrollarea = new QScrollArea;
	scrollarea->setParent(this);
	scrollconts = new QWidget;
	scrollconts->setParent(this);
	vbxlayout = new QVBoxLayout;
	scrollarea->setWidget(scrollconts);
	scrollconts->setLayout(vbxlayout);
        addallevwidgets();
        searchbox = new QLineEdit(this);
        searchtype = new QComboBox(this);
        searchtype->addItems(QStringList() << "All" <<  "Summary" << "Description" << "Time");
        searchbox->setGeometry(132, 510, 192, 28);
        searchtype->setGeometry(4, 510, 111, 27);
        searchbox->show();
        searchtype->show();
	connect(searchbox, SIGNAL(textEdited(QString)), this, SLOT(filterevwidgets(QString)));
	connect(searchtype, SIGNAL(currentIndexChanged(int)), this, SLOT(changesearchcategory()));
}

void deadlineplane::limevwidgets()
{
	/*
	for (int i = 0; i < evlimwidgetlist.size(); ++i)
	{
		evlimwidgetlist[i]->setParent(scrollconts);
		connect(evlimwidgetlist[i], SIGNAL(evselected(evwidget*)), this, SLOT(evselected(evwidget*)));
		vbxlayout->addWidget(evlimwidgetlist[i]);
		qDebug() << evlimwidgetlist[i]->curevent->totext();
	}
	redrawev();
	scrollconts->adjustSize();
	*/
	for (int i = 0; i < evwidgetlist.size(); ++i)
	{
		if (!evlimwidgetlist.contains(evwidgetlist[i]))
		{
			vbxlayout->removeWidget(evwidgetlist[i]);
		}
	}
	scrollconts->adjustSize();
}

void deadlineplane::readdevwidgets()
{
	for (int i = 0; i < evlimwidgetlist.size(); ++i)
	{
//		scrollarea->setWidget(evwidgetlist[i]);
//		evwidgetlist[i]->setParent(scrollconts);
//		connect(evwidgetlist[i], SIGNAL(evselected(evwidget*)), this, SLOT(evselected(evwidget*)));
		vbxlayout->addWidget(evlimwidgetlist[i]);
//		qDebug() << evlimwidgetlist[i]->curevent->totext();
	}
//	redrawev();
	scrollconts->adjustSize();
}

void deadlineplane::addallevwidgets()
{
	for (int i = 0; i < evwidgetlist.size(); ++i)
	{
//		scrollarea->setWidget(evwidgetlist[i]);
		evwidgetlist[i]->setParent(scrollconts);
		connect(evwidgetlist[i], SIGNAL(evselected(evwidget*)), this, SLOT(evselected(evwidget*)));
//		evwidgetlist[i]->setParent(vbxlayout);
//		evwidgetlist[i]->move(0, i*120);
//		evwidgetlist[i]->repaint();
//		evwidgetlist[i]->refreshev();
		vbxlayout->addWidget(evwidgetlist[i]);
//		evwidgetlist[i]->show();
//		show();
//		qDebug() << evwidgetlist[i]->curevent->totext();
//		scrollarea->ensureWidgetVisible(evwidgetlist[i]);
	}
	evlimwidgetlist.clear();
	evlimwidgetlist = QList<evwidget*>(evwidgetlist);
//	scrollarea->show();
//	graphicsview->show();
//	this->show();
	redrawev();
//	scrollconts->resize(2000, 2000);
	scrollconts->adjustSize();
//	scrollarea->adjustSize();
//	vbxlayout->adjustSize();
//	vbxlayout->show();
//	scrollarea->repaint();
}

void deadlineplane::addevwidgets(QList<evwidget*> addwidgets)
{
	for (int i = 0; i < addwidgets.size(); ++i)
	{
		evlimwidgetlist.append(addwidgets[i]);
		vbxlayout->addWidget(addwidgets[i]);
	}
	scrollconts->adjustSize();
}

void deadlineplane::remevwidgets(QList<evwidget*> remwidgets)
{
	for (int i = 0; i < remwidgets.size(); ++i)
	{
		evlimwidgetlist.removeAll(remwidgets[i]);
		vbxlayout->removeWidget(remwidgets[i]);
	}
	scrollconts->adjustSize();
}

bool deadlineplane::searchmatched(evwidget *searchedwidget, QString filtertext)
{
//	return searchedwidget->curevent->totext().contains(filtertext, Qt::CaseInsensitive);
	if (searchtype->currentText() == "All")
	{
		return searchedwidget->curevent->totext().contains(filtertext, Qt::CaseInsensitive);
	}
	if (searchtype->currentText() == "Summary")
	{
		return searchedwidget->curevent->evsummary.contains(filtertext, Qt::CaseInsensitive);
	}
	if (searchtype->currentText() == "Description")
	{
		return searchedwidget->curevent->evdescription.contains(filtertext, Qt::CaseInsensitive);
	}
// todo time and date search
	return false;
}

void deadlineplane::changesearchcategory()
{
	evlimwidgetlist.clear();
//	evlimwidgetlist = QList<evwidget*>(evwidgetlist);
	addevwidgets(evwidgetlist);
	filterevwidgets(searchbox->text());
}

void deadlineplane::filterevwidgets(QString filtertext)
{
	if (filtertext.contains(prevsentry)) // we're making the search more specific, limiting (removing) entries not adding them, can search existing entries
	{
		/*
		QList<int> rmindextmp;
		for (int i = 0; i < evlimwidgetlist.size(); ++i)
		{
			if (!evlimwidgetlist[i]->curevent->totext().contains(filtertext)) // mark for removal from list if it doesn't contain the text
			{
				rmindextmp.append(i);
			}
		}
		for (int i = 0; i < rmindextmp.size(); ++i) // actually remove the entries that were marked for removal
		{
			evlimwidgetlist.removeAt(rmindextmp[i]);
		}
		limevwidgets(); // removes corresponding widgets
//		prevsentry = filtertext;
		*/
		QList<evwidget*> toberemoved;
		for (int i = 0; i < evlimwidgetlist.size(); ++i)
		{
			if (!searchmatched(evlimwidgetlist[i], filtertext)) // mark for removal from list if it doesn't contain the text
			{
				toberemoved.append(evlimwidgetlist[i]);
			}
		}
		remevwidgets(toberemoved);
	}
	else // new string entirely, repopulate the widget list and search it
	{
		/*
		evlimwidgetlist.clear();
//		evlimwidgetlist = QList<evwidget*>(evwidgetlist);
		for (int i = 0; i < evwidgetlist.size(); ++i)
		{
			if (evwidgetlist[i]->curevent->totext().contains(filtertext))
			{
				evlimwidgetlist.append(evwidgetlist[i]);
			}
		}
		readdevwidgets();
		*/
		evlimwidgetlist.clear();
		QList<evwidget*> tobeadded;
		for (int i = 0; i < evwidgetlist.size(); ++i)
		{
			if (searchmatched(evwidgetlist[i], filtertext)) // mark for addition
			{
				tobeadded.append(evwidgetlist[i]);
			}
		}
		addevwidgets(tobeadded);
	}
	/*
	evlimwidgetlist.clear();
	for (int i = 0; i < evwidgetlist.size(); ++i)
	{
		if (evwidgetlist[i]->curevent->totext().contains(filtertext))
		{
			evlimwidgetlist.append(evwidgetlist[i]);
		}
	}
	limevwidgets();
	*/
	prevsentry = filtertext;
}

/*
void deadlineplane::shiftup()
{
	centertime = curdisplist[curdispmid+1]->todatetimesta();
	qDebug() << centertime;
	curdisplist = evparser->nearevlist(centertime, curdispsize+1);
	for (int i = 0; i < evwidgetlist.size(); ++i)
	{
		evwidgetlist[i]->curevent = curdisplist[i];
	}
	redrawev();
//	qDebug() << "going up";
//	redrawev();
}

void deadlineplane::shiftdown()
{
	centertime = curdisplist[curdispmid-1]->todatetimesta();
	qDebug() << centertime;
	curdisplist = evparser->nearevlist(centertime, curdispsize+1);
	for (int i = 0; i < evwidgetlist.size(); ++i)
	{
		evwidgetlist[i]->curevent = curdisplist[i];
	}
	redrawev();
//	qDebug() << "going down";
//	evwidgetlist[1]->curevent->evsummary = "meo";
//	redrawev();
}
*/

void deadlineplane::evselected(evwidget *evwsel)
{
	if (curevwidget != NULL && evwidgetlist.contains(curevwidget))
	{
		if (curevwidget->styleSheet() == "background: yellow")
			curevwidget->setStyleSheet("");
	}
	curevwidget = evwsel;
	evwsel->setStyleSheet("background: yellow");
	metavp->setDispContents(evwsel->curevent->todata());
//	metavp->setDispContents(evwsel->curevent->tohtml());
//	remotevp->setDispContents(evwsel->curevent->tohtml());
}

void deadlineplane::redrawev()
{
	for (int i = 0; i < evwidgetlist.size(); ++i)
	{
		evwidgetlist[i]->refreshev();
	}
}

