#include "genfunc.h"

QByteArray genfunc::downloadpagecontents(QString pageurl)
{
        QUrl pgurl(pageurl);
        QHttp pghttp;
        QEventLoop pgwait;
        QObject::connect(&pghttp, SIGNAL(done(bool)), &pgwait, SLOT(quit()));
        pghttp.setHost(pgurl.host());
        QString realpgupath = QString(pageurl).remove(0, pageurl.indexOf(QString("://%1").arg(pgurl.host())) + QString("://%1").arg(pgurl.host()).length());
        QHttpRequestHeader pgrequest;
        pgrequest.setRequest("GET", realpgupath);
        pgrequest.setValue("HOST", pgurl.host());
        pgrequest.setValue("User-Agent", "TDE/1.1.1");
//	pgrequest.setValue("User-Agent", "Wget/1.10.2");
        pgrequest.setValue("Accept", "*/*");
        pgrequest.setValue("Connection", "Keep-Alive");
        pghttp.request(pgrequest);
        pgwait.exec();
        QHttpResponseHeader pgresponse(pghttp.lastResponse());
        int pgrstatus = pgresponse.statusCode();
        if (pgrstatus >= 300 && pgrstatus < 400 && pgresponse.hasKey("Location"))
        {
                return downloadpagecontents(pgresponse.value("Location"));
        }
        else
        {
                return pghttp.readAll();
        }
}

QString genfunc::formatdatatype(QString fulltextdata)
{
//        QString fulltextdata = QString("%1\n%2").arg(evsummary).arg(evdescription);
        QRegExp videourlrx("http://\\S{0,}.(avi|mp4|mov|ogv|ogg|mkv|flv)");
        QRegExp pdfurlrx("http://\\S{0,}.(pdf)");
        QRegExp plainurlrx("http://\\S{0,}.(htm|html|php|jsp|asp|aspx)");
        if (fulltextdata.contains(videourlrx)) // video url
        {
                return QString("video...%1").arg(fulltextdata.mid(videourlrx.indexIn(fulltextdata), videourlrx.matchedLength()));
        }
        else if (fulltextdata.contains(pdfurlrx)) // pdf url
        {
            return QString("pdf.....%1").arg(fulltextdata.mid(pdfurlrx.indexIn(fulltextdata), pdfurlrx.matchedLength()));
        }
        else if (fulltextdata.contains(plainurlrx)) // plain url
        {
            return QString("webpage.%1").arg(fulltextdata.mid(plainurlrx.indexIn(fulltextdata), plainurlrx.matchedLength()));
        }
        else // plain text
        {
            return QString("text....%1").arg(fulltextdata);
//                return QString("text....%1").arg(tohtml());
        }
}
