#include "icalparser.h"

icalparser::icalparser()
{
//    sqlmaindb = new QSqlDatabase;
/*
    QSqlDatabase sqlmaindb = QSqlDatabase::addDatabase("QSQLITE");
    sqlmaindb.setDatabaseName("tdedb");
    sqlmaindb.open();
    sqltable = new QSqlTableModel(this, sqlmaindb);
*/
}

icalparser::~icalparser()
{
}

QStringList icalparser::listfilesintree(QString treeloc, QStringList filelist)
{
//	QStringList filelist;
	QDir curdir(treeloc);
	QFileInfoList subfiledirs = curdir.entryInfoList();
//	QStringList curfiles = curdir.entryInfoList(QDir::Files);
//	filelist += curdir.entryList(QDir::Files);
	for (int i = 0; i < subfiledirs.size(); ++i)
	{
		if (subfiledirs[i].isFile())
			filelist.append(QString("%1/%2").arg(treeloc).arg(subfiledirs[i].fileName()));
	}
	for (int i = 0; i < subfiledirs.size(); ++i)
	{
		if (subfiledirs[i].isDir() && subfiledirs[i].fileName() != "." && subfiledirs[i].fileName() != "..")
			filelist += listfilesintree(QString("%1/%2").arg(treeloc).arg(subfiledirs[i].fileName()));
	}
//	qDebug() << filelist;
	/*
	QStringList subdirs = curdir.entryList(QDir::Dirs);
//	qDebug() << subdirs;
	subdirs.removeAll(".");
	subdirs.removeAll("..");
//	qDebug() << subdirs;
	for (int i = 0; i < subdirs.size(); ++i)
	{
		filelist += listfilesintree(QString("%1/%2").arg(treeloc).arg(subdirs[i]), filelist);
	}
	qDebug() << filelist;
	*/
	return filelist;
}

QStringList icalparser::listfilesintree(QString treeloc)
{
	return listfilesintree(treeloc, QStringList());
}

void icalparser::parsetree(QString treeloc)
{
	QStringList icalfilelocs = listfilesintree(treeloc).filter(QRegExp(".ics$"));
	for (int i = 0; i < icalfilelocs.size(); ++i)
	{
		parsefile(icalfilelocs[i]);
//		parsefile(QString("%1/%2").arg(treeloc).arg(icalfilelocs[i]));
	}
}

void icalparser::parsefile()
{
	parsefile(curfilepath);
}

void icalparser::parsefile(QString icalfilepath)
{
	curfile.setFileName(icalfilepath);
	curfile.open(QIODevice::ReadOnly);
	curtextstream.setDevice(&curfile);
//	int icalindex = -1;
	while (!curtextstream.atEnd())
	{
		QString ccaline = curtextstream.readLine();
		if (ccaline.contains(QRegExp("^BEGIN:VEVENT")))
		{
			icallist.append(new icalindv);
		}
		if (icallist.isEmpty())
			continue;
		if (ccaline.contains(QRegExp("^DTSTART:")))
		{
			icallist[icallist.size()-1]->evdatesta = QDate::fromString(QString(ccaline).remove(QRegExp("^DTSTART:")).left(8), "yyyyMMdd");
			icallist[icallist.size()-1]->evtimesta = QTime::fromString(QString(ccaline).remove(QRegExp("^DTSTART:")).remove(QRegExp("\\D")).right(6), "hhmmss");
		}
		if (ccaline.contains(QRegExp("^DTEND:")))
		{
			icallist[icallist.size()-1]->evdateend = QDate::fromString(QString(ccaline).remove(QRegExp("^DTEND:")).left(8), "yyyyMMdd");
			icallist[icallist.size()-1]->evtimeend = QTime::fromString(QString(ccaline).remove(QRegExp("^DTEND:")).remove(QRegExp("\\D")).right(6), "hhmmss");
		}
		if (ccaline.contains(QRegExp("^DTSTART;VALUE=DATE:")))
		{
			icallist[icallist.size()-1]->evdatesta = QDate::fromString(QString(ccaline).remove(QRegExp("^DTSTART;VALUE=DATE:")).left(8), "yyyyMMdd");
//			icallist[icallist.size()-1]->evtimesta = QString(ccaline).remove(QRegExp("^DTSTART:")).remove(QRegExp("\\D")).right(6);
		}
		if (ccaline.contains(QRegExp("^DTEND;VALUE=DATE:")))
		{
			icallist[icallist.size()-1]->evdateend = QDate::fromString(QString(ccaline).remove(QRegExp("^DTEND;VALUE=DATE:")).left(8), "yyyyMMdd");
//			icallist[icallist.size()-1]->evtimesta = QString(ccaline).remove(QRegExp("^DTSTART:")).remove(QRegExp("\\D")).right(6);
		}
		if (ccaline.contains(QRegExp("^SUMMARY:")))
		{
//			icallist.append(icalindv());
//			++icalindex;
			icallist[icallist.size()-1]->evsummary = QString(ccaline).remove(QRegExp("^SUMMARY:"));
//			qDebug() << QString(ccaline).remove(QRegExp("^SUMMARY:"));
//			qDebug() << icallist[icallist.size()-1]->totext();
		}
		if (ccaline.contains(QRegExp("^DESCRIPTION:")) && !ccaline.contains(QRegExp("^DESCRIPTION:Mozilla Alarm:")))
		{
			icallist[icallist.size()-1]->evdescription = QString(ccaline).remove(QRegExp("^DESCRIPTION:"));
		}
	}
//	for (int i = 0; i < icallist.size(); ++i)
//	{
//		qDebug() << icallist[i]->totext();
//	}
}


QList<icalindv*> icalparser::orderlistup(QList<icalindv*> unorlist)
{
	// organizes list from smallest (earliest) to largest (latest)
	if (unorlist.size() < 2)
		return unorlist;
	QList<icalindv*> ordevlist;
	ordevlist.append(unorlist[0]);
	for (int i = 1; i < unorlist.size(); ++i)
	{
		bool haveappended = false;
		for (int j = 0; j < ordevlist.size(); ++j)
		{
			if (unorlist[i]->todatetimesta() < ordevlist[j]->todatetimesta())
			{
				ordevlist.insert(j, unorlist[i]);
				haveappended = true;
				break;
			}
		}
		if (!haveappended)
			ordevlist.append(unorlist[i]);
	}
	return ordevlist;
}

QList<icalindv*> icalparser::orderlistdown(QList<icalindv*> unorlist)
{
	// organizes list from largest (latest) to smallest (earliest)
	if (unorlist.size() < 2)
		return unorlist;
	QList<icalindv*> ordevlist;
	ordevlist.append(unorlist[0]);
	for (int i = 1; i < unorlist.size(); ++i)
	{
		bool haveappended = false;
		for (int j = 0; j < ordevlist.size(); ++j)
		{
			if (unorlist[i]->todatetimesta() > ordevlist[j]->todatetimesta())
			{
				ordevlist.insert(j, unorlist[i]);
				haveappended = true;
				break;
			}
		}
		if (!haveappended)
			ordevlist.append(unorlist[i]);
	}
	return ordevlist;
}

QList<icalindv*> icalparser::nextevlist(QDateTime refdatetime, int evlistsize)
{
	QList<icalindv*> tmpevlist;
	// expects an order-up list
//	for (int i = icallist.size()-1; i >= 0; --i)
	for (int i = 0; i < icallist.size(); ++i)
	{
		if (icallist[i]->todatetimesta() < refdatetime)
			continue;
		if (tmpevlist.size() >= evlistsize)
			break;
		tmpevlist.append(icallist[i]);
	}
	/*
//	QList<icalindv*> ordevlist;
	for (int i = 0; i < icallist.size(); ++i)
	{
		if (icallist[i]->todatetimesta() < refdatetime)
			continue;
		if (tmpevlist.size() >= evlistsize)
			break;
//		tmpevlist.append(icallist[i]);
		
		if (tmpevlist.isEmpty()) // source of troubles, can't guarantee that the first element that satisfies condition is among the n earliest
		{
			tmpevlist.append(icallist[i]);
			continue;
		}
		
		bool haveappended = false;
		for (int j = 0; j < tmpevlist.size(); ++j)
		{
			if (icallist[i]->todatetimesta() < tmpevlist[j]->todatetimesta())
			{
				tmpevlist.insert(j, icallist[i]); // prepends entries, events will be organized earliest to latest
				haveappended = true;
				break;
			}
//			tmpevlist.append(icallist[i]); // if we're here this must be the largest element in the list
		}
		if (!haveappended)
			tmpevlist.append(icallist[i]); // if we're here this must be the largest element in the list
	*/
		/*
		for (int j = 0; j < tmpevlist.size(); ++j) // orders entries earliest to latest
		{
			if (icallist[i]->todatetimesta() < tmpevlist[j]->todatetimesta())
			{
				ordevlist.insert(j, icallist[i]); // prepends entries, events will be organized earliest to latest
			}
			else if (j == tmpevlist.size()-1) // true if event is larger (later) than any other in tmpevlist
			{
				ordevlist.append(icallist[i]);
			}
		}
		*/
		
//	}
//	return orderlistup(tmpevlist);
	return tmpevlist;
}

QList<icalindv*> icalparser::nextevlist(int evlistsize)
{
	return nextevlist(QDateTime::currentDateTime().toUTC(), evlistsize);
}

QList<icalindv*> icalparser::prevevlist(QDateTime refdatetime, int evlistsize)
{
	QList<icalindv*> tmpevlist;
	// expects an order-up list
//	for (int i = icallist.size()-1; i >= 0; --i)
	for (int i = 0; i < icallist.size(); ++i)
	{
		if (icallist[i]->todatetimesta() > refdatetime)
			continue;
		if (tmpevlist.size() >= evlistsize)
			break;
		tmpevlist.append(icallist[i]);
	}
	/*
//	QList<icalindv*> ordevlist;
	for (int i = icallist.size()-1; i >= 0; --i)
	{
		if (icallist[i]->todatetimesta() > refdatetime)
			continue;
		if (tmpevlist.size() >= evlistsize)
			break;
//		tmpevlist.append(icallist[i]);
		
		if (tmpevlist.isEmpty()) // source of troubles, can't guarantee that the first element that satisfies condition is among the n latest
		{
			tmpevlist.append(icallist[i]);
			continue;
		}
		
		bool haveappended = false;
		for (int j = 0; j > tmpevlist.size(); ++j)
		{
			if (icallist[i]->todatetimesta() > tmpevlist[j]->todatetimesta())
			{
				tmpevlist.insert(j, icallist[i]); // prepends entries, events will be organized latest to earliest
				haveappended = true;
				break;
			}
//			tmpevlist.append(icallist[i]); // if we're here this must be the smallest element in the list
		}
		if (!haveappended)
			tmpevlist.append(icallist[i]); // if we're here this must be the smallest element in the list
	*/
		/*
		for (int j = 0; j < tmpevlist.size(); ++j) // orders entries latest to earliest
		{
			if (icallist[i]->todatetimesta() > tmpevlist[j]->todatetimesta())
			{
				ordevlist.insert(j, icallist[i]); // prepends entries, events will be organized latest to earliest
			}
			else if (j == tmpevlist.size()-1) // true if event is smaller (earlier) than any other in tmpevlist
			{
				ordevlist.append(icallist[i]);
			}
		}
		*/
//	}
//	return orderlistdown(tmpevlist);
	return tmpevlist;
}

QList<icalindv*> icalparser::prevevlist(int evlistsize)
{
	return prevevlist(QDateTime::currentDateTime().toUTC(), evlistsize);
}

QList<icalindv*> icalparser::nearevlist(QDateTime refdatetime, int evlistsize)
{
	return prevevlist(refdatetime, 3)+nextevlist(refdatetime, 3); // todo
}

QList<icalindv*> icalparser::nearevlist(int evlistsize)
{
	return nearevlist(QDateTime::currentDateTime().toUTC(), evlistsize);
}

QList<evwidget*> icalparser::towidgetlist(QList<icalindv*> evlist)
{
	QList<evwidget*> widgetlist;
	for (int i = 0; i < evlist.size(); ++i)
	{
		evwidget *nevwg = new evwidget;
		nevwg->curevent = evlist[i];
		widgetlist.append(nevwg);
//		qDebug() << nevwg->curevent->evsummary;
	}
	return widgetlist;
}
