#include "viewplane.h"

viewplane::viewplane(QWidget *parent, int portnum)
	: QTextBrowser(parent)
{
    if (parent)
        this->setGeometry(0, 0, parent->width(), parent->height());
//        this->setGeometry(parent->geometry());
//    qDebug() << parent->geometry();
//   
//        this->setGeometry(this-> x(), this->y(), 640, 480);
        udpSocket = new QUdpSocket(this);
        webpageView = new QWebView(this);
        webpageView->setGeometry(this->geometry());
//        pdfDisplay = new QLabel(this);
//        pdfRender.grabWidget(this, this->geometry());
//        pdfRender = new QImage(this);
	mediaObject = new Phonon::MediaObject(this);
//	videoWidget = new Phonon::VideoWidget(this);
        videoWidget = new vdwidget();
        videoWidget->setParent(this);
        videoWidget->setGeometry(this->geometry());
        videoWidget->setup();
        pdfWidget = new pdwidget();
        pdfWidget->setParent(this);
        pdfWidget->setGeometry(this->geometry());
        pdfWidget->setup();
//        pdfDisplay = new QLabel(pdfWidget);
//        connect(videoWidget, SIGNAL(playv()), this, SLOT(playv()));
//        connect(videoWidget, SIGNAL(pausev()), this, SLOT(pausev()));
//        videoWidget->setGeometry(this->geometry());
//        qDebug() << videoWidget->geometry() << this->geometry();
  //      videoWidget->pauseplayb->setGeometry(this->width()/2, this->height()/2, 20, 20);
        audioOutput = new Phonon::AudioOutput(Phonon::VideoCategory, this);
	Phonon::createPath(mediaObject, videoWidget);
        Phonon::createPath(mediaObject, audioOutput);
	isremote = true;
	broadcastport = portnum;
	hideotherw();
//	broadcastport = 45454;
}

viewplane::~viewplane()
{

}

void viewplane::playv()
{
    if (isremote)
        senddatagram(QByteArray("SIGNALplayv"));
    else
    {
        videoWidget->pauseplayb->setText("Pause");
        mediaObject->play();
    }
}

void viewplane::pausev()
{
    if (isremote)
        senddatagram(QByteArray("SIGNALpausev"));
    else
    {
        videoWidget->pauseplayb->setText("Play");
        mediaObject->pause();
    }
}

void viewplane::hideotherw()
{
	mediaObject->stop();
        videoWidget->hide();
        webpageView->hide();
//        pdfDisplay->hide();
        pdfWidget->hide();
}

void viewplane::vdisplayData(QString dispcontents)
{
	if (dispcontents.size() <= 8) // no data
		return;
	QString datatype = QString(dispcontents).left(8).remove(".");
	QString rawdata = QString(dispcontents).remove(0, 8);
        if (datatype == "video")
                vdisplayVideo(rawdata);
        else if (datatype == "pdf")
            vdisplayPDF(rawdata);
        else if (datatype == "webpage")
            vdisplayWebpage(rawdata);
        else if (datatype == "text")
                vdisplayText(rawdata);
}

void viewplane::vdisplayText(QString dispcontents)
{
	hideotherw();
	this->setHtml(dispcontents);
}

void viewplane::vdisplayVideo(QString dispcontents)
{
	hideotherw();
	videoWidget->show();
	mediaObject->setCurrentSource(Phonon::MediaSource(dispcontents));
	mediaObject->play();
}

void viewplane::vdisplayWebpage(QString dispcontents)
{
        hideotherw();
        webpageView->load(QUrl(dispcontents));
        webpageView->show();
}

void viewplane::nextpagep()
{
    if (isremote)
        senddatagram(QByteArray("SIGNALnextpagep"));
    else if (pdfWidget->curpagenum < pdfWidget->pdfDocument->numPages()-1)
    {
        pdfWidget->curpagenum++;
        pdfWidget->vrenderpage();
    }
}

void viewplane::prevpagep()
{
    if (isremote)
        senddatagram(QByteArray("SIGNALprevpagep"));
    else if (pdfWidget->curpagenum != 0)
    {
        pdfWidget->curpagenum--;
        pdfWidget->vrenderpage();
    }
}

/*
void viewplane::vrenderpage()
{
    pdfPage = pdfDocument->page(curpagenum);
    pdfRender = pdfPage->renderToImage();
    pdfDisplay->setPixmap(QPixmap::fromImage(pdfRender));
    pdfDisplay->show();
}
*/

void viewplane::vdisplayPDF(QString dispcontents)
{
        hideotherw();
        pdfWidget->pagedata = genfunc::downloadpagecontents(dispcontents);
        pdfWidget->curpagenum = 0;
        pdfWidget->vrenderpage();
//        pdfWidget->show();
//        pdfDocument = Poppler::Document::loadFromData(downloadpagecontents(dispcontents));
//        pdfDocument = Poppler::Document::load("/home/geza/file.pdf"); // TODO remote file loading via QHttp and QFtp
//        pdfDocument = Poppler::Document::load(dispcontents);
//        curpagenum = 0;
//        vrenderpage();

        /*
        pdfPage = pdfDocument->page(curpagenum);
        pdfRender = pdfPage->renderToImage();
//        pdfRender.grabWidget(this, this->geometry());
        pdfDisplay->setPixmap(QPixmap::fromImage(pdfRender));
        pdfDisplay->show();
        */
}

void viewplane::senddatagram(QByteArray datagram)
{
    udpSocket->writeDatagram(datagram.data(), datagram.size(), QHostAddress::Broadcast, broadcastport);
}

void viewplane::senddatagram(QString datagram)
{
    QByteArray datagramB;
    datagramB.append(datagram);
    udpSocket->writeDatagram(datagramB.data(), datagramB.size(), QHostAddress::Broadcast, broadcastport);
}

void viewplane::setDispContents(QString dispcontents)
{
        if (isremote)
        {
            senddatagram(dispcontents);
        }
        else
	{
		vdisplayData(dispcontents);
	}
}
